<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: checks/checks.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_1abab4d757f86d382fea5dfa8cdf1fc3.html">checks</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a>  </div>
  <div class="headertitle">
<div class="title">checks.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdint.h&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for checks.h:</div>
<div class="dyncontent">
<div class="center"><img src="checks_8h__incl.png" border="0" usemap="#checks_2checks_8h" alt=""/></div>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="checks_8h__dep__incl.png" border="0" usemap="#checks_2checks_8hdep" alt=""/></div>
<map name="checks_2checks_8hdep" id="checks_2checks_8hdep">
<area shape="rect" id="node2" href="test__checks_8c.html" title="checks/test_checks.c" alt="" coords="5,80,156,107"/>
</map>
</div>
</div>
<p><a href="checks_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a73a88126cb5a68f140354e51ffa1bb48"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a73a88126cb5a68f140354e51ffa1bb48">ADD_UINT64_WRAPS</a>(a,  b)&#160;&#160;&#160;(UINT64_MAX - a &lt; b)</td></tr>
<tr class="separator:a73a88126cb5a68f140354e51ffa1bb48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af27751fa54ede07b9ce8cb537ce84450"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#af27751fa54ede07b9ce8cb537ce84450">ADD_UINT32_WRAPS</a>(a,  b)&#160;&#160;&#160;(UINT32_MAX - a &lt; b)</td></tr>
<tr class="separator:af27751fa54ede07b9ce8cb537ce84450"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f4881d8ea242a2356e82b1fa8706d8b"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a1f4881d8ea242a2356e82b1fa8706d8b">ADD_UINT16_WRAPS</a>(a,  b)&#160;&#160;&#160;(UINT16_MAX - a &lt; b)</td></tr>
<tr class="separator:a1f4881d8ea242a2356e82b1fa8706d8b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a599548d88482f8e91f345a0e5645d9bf"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a599548d88482f8e91f345a0e5645d9bf">ADD_UINT8_WRAPS</a>(a,  b)&#160;&#160;&#160;(UINT8_MAX - a &lt; b)</td></tr>
<tr class="separator:a599548d88482f8e91f345a0e5645d9bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af178ceb736d6ed5678e1a3245ed005d4"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#af178ceb736d6ed5678e1a3245ed005d4">SUB_U_WRAPS</a>(a,  b)&#160;&#160;&#160;(a &lt; b)</td></tr>
<tr class="separator:af178ceb736d6ed5678e1a3245ed005d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a319eab81855471921c64c9811568d95e"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a319eab81855471921c64c9811568d95e">UINT64_TO_UINT32_LOSS</a>(a)&#160;&#160;&#160;(a &gt; UINT32_MAX)</td></tr>
<tr class="separator:a319eab81855471921c64c9811568d95e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d2692aba22265de50090e52cad6d89c"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a0d2692aba22265de50090e52cad6d89c">UINT32_TO_UINT16_LOSS</a>(a)&#160;&#160;&#160;(a &gt; UINT16_MAX)</td></tr>
<tr class="separator:a0d2692aba22265de50090e52cad6d89c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2356ecefba09f816cb8912fba37cf58"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#ae2356ecefba09f816cb8912fba37cf58">UINT16_TO_UINT8_LOSS</a>(a)&#160;&#160;&#160;(a &gt; UINT8_MAX)</td></tr>
<tr class="separator:ae2356ecefba09f816cb8912fba37cf58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a800ffb9294adf32e0544a9af9916c50b"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a800ffb9294adf32e0544a9af9916c50b">UINT64_TO_INT64_LOSS</a>(a)&#160;&#160;&#160;(a &gt; INT64_MAX)</td></tr>
<tr class="separator:a800ffb9294adf32e0544a9af9916c50b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d17f4f306188e5ec0d4bb7077b1bd5d"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a6d17f4f306188e5ec0d4bb7077b1bd5d">UINT32_TO_INT32_LOSS</a>(a)&#160;&#160;&#160;(a &gt; INT32_MAX)</td></tr>
<tr class="separator:a6d17f4f306188e5ec0d4bb7077b1bd5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a09875c25cc5338183a477eb92f5d0e2a"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a09875c25cc5338183a477eb92f5d0e2a">UINT16_TO_INT16_LOSS</a>(a)&#160;&#160;&#160;(a &gt; INT16_MAX)</td></tr>
<tr class="separator:a09875c25cc5338183a477eb92f5d0e2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a083dcd88d02f6161c6c3639a2ae630"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="checks_8h.html#a0a083dcd88d02f6161c6c3639a2ae630">UINT8_TO_INT8_LOSS</a>(a)&#160;&#160;&#160;(a &gt; INT8_MAX)</td></tr>
<tr class="separator:a0a083dcd88d02f6161c6c3639a2ae630"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Checks for success of arithmetic operations. </p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a1f4881d8ea242a2356e82b1fa8706d8b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f4881d8ea242a2356e82b1fa8706d8b">&#9670;&nbsp;</a></span>ADD_UINT16_WRAPS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define ADD_UINT16_WRAPS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">b&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;(UINT16_MAX - a &lt; b)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="af27751fa54ede07b9ce8cb537ce84450"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af27751fa54ede07b9ce8cb537ce84450">&#9670;&nbsp;</a></span>ADD_UINT32_WRAPS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define ADD_UINT32_WRAPS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">b&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;(UINT32_MAX - a &lt; b)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a73a88126cb5a68f140354e51ffa1bb48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a73a88126cb5a68f140354e51ffa1bb48">&#9670;&nbsp;</a></span>ADD_UINT64_WRAPS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define ADD_UINT64_WRAPS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">b&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;(UINT64_MAX - a &lt; b)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a599548d88482f8e91f345a0e5645d9bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a599548d88482f8e91f345a0e5645d9bf">&#9670;&nbsp;</a></span>ADD_UINT8_WRAPS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define ADD_UINT8_WRAPS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">b&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;(UINT8_MAX - a &lt; b)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="af178ceb736d6ed5678e1a3245ed005d4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af178ceb736d6ed5678e1a3245ed005d4">&#9670;&nbsp;</a></span>SUB_U_WRAPS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SUB_U_WRAPS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">b&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;(a &lt; b)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a09875c25cc5338183a477eb92f5d0e2a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a09875c25cc5338183a477eb92f5d0e2a">&#9670;&nbsp;</a></span>UINT16_TO_INT16_LOSS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UINT16_TO_INT16_LOSS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a</td><td>)</td>
          <td>&#160;&#160;&#160;(a &gt; INT16_MAX)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ae2356ecefba09f816cb8912fba37cf58"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2356ecefba09f816cb8912fba37cf58">&#9670;&nbsp;</a></span>UINT16_TO_UINT8_LOSS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UINT16_TO_UINT8_LOSS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a</td><td>)</td>
          <td>&#160;&#160;&#160;(a &gt; UINT8_MAX)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a6d17f4f306188e5ec0d4bb7077b1bd5d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d17f4f306188e5ec0d4bb7077b1bd5d">&#9670;&nbsp;</a></span>UINT32_TO_INT32_LOSS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UINT32_TO_INT32_LOSS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a</td><td>)</td>
          <td>&#160;&#160;&#160;(a &gt; INT32_MAX)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a0d2692aba22265de50090e52cad6d89c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0d2692aba22265de50090e52cad6d89c">&#9670;&nbsp;</a></span>UINT32_TO_UINT16_LOSS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UINT32_TO_UINT16_LOSS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a</td><td>)</td>
          <td>&#160;&#160;&#160;(a &gt; UINT16_MAX)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a800ffb9294adf32e0544a9af9916c50b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a800ffb9294adf32e0544a9af9916c50b">&#9670;&nbsp;</a></span>UINT64_TO_INT64_LOSS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UINT64_TO_INT64_LOSS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a</td><td>)</td>
          <td>&#160;&#160;&#160;(a &gt; INT64_MAX)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a319eab81855471921c64c9811568d95e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a319eab81855471921c64c9811568d95e">&#9670;&nbsp;</a></span>UINT64_TO_UINT32_LOSS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UINT64_TO_UINT32_LOSS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a</td><td>)</td>
          <td>&#160;&#160;&#160;(a &gt; UINT32_MAX)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a0a083dcd88d02f6161c6c3639a2ae630"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0a083dcd88d02f6161c6c3639a2ae630">&#9670;&nbsp;</a></span>UINT8_TO_INT8_LOSS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UINT8_TO_INT8_LOSS</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a</td><td>)</td>
          <td>&#160;&#160;&#160;(a &gt; INT8_MAX)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
